package com.sun.xml.internal.ws.developer;

import com.sun.org.glassfish.gmbal.ManagedAttribute;
import javax.xml.bind.JAXBException;
import com.sun.xml.internal.bind.api.TypeReference;
import java.util.List;
import com.sun.xml.internal.ws.api.model.SEIModel;
import com.sun.xml.internal.bind.api.JAXBRIContext;
import com.sun.istack.internal.Nullable;
import com.sun.xml.internal.ws.api.FeatureConstructor;
import java.lang.reflect.InvocationTargetException;
import com.sun.istack.internal.NotNull;
import com.sun.org.glassfish.gmbal.ManagedData;
import javax.xml.ws.WebServiceFeature;

@ManagedData
public class UsesJAXBContextFeature extends WebServiceFeature
{
    public static final String ID = "http://jax-ws.dev.java.net/features/uses-jaxb-context";
    private final JAXBContextFactory factory;
    
    @FeatureConstructor({ "value" })
    public UsesJAXBContextFeature(@NotNull Class<? extends JAXBContextFactory> factoryClass) {
        try {
            this.factory = (JAXBContextFactory)factoryClass.getConstructor(new Class[0]).newInstance(new Object[0]);
        }
        catch (InstantiationException e) {
            Error x = new InstantiationError(e.getMessage());
            x.initCause(e);
            throw x;
        }
        catch (IllegalAccessException e2) {
            Error x = new IllegalAccessError(e2.getMessage());
            x.initCause(e2);
            throw x;
        }
        catch (InvocationTargetException e3) {
            Error x = new InstantiationError(e3.getMessage());
            x.initCause(e3);
            throw x;
        }
        catch (NoSuchMethodException e4) {
            Error x = new NoSuchMethodError(e4.getMessage());
            x.initCause(e4);
            throw x;
        }
    }
    
    public UsesJAXBContextFeature(@Nullable JAXBContextFactory factory) {
        this.factory = factory;
    }
    
    public UsesJAXBContextFeature(@Nullable final JAXBRIContext context) {
        this.factory = new JAXBContextFactory() {
            @NotNull
            @Override
            public JAXBRIContext createJAXBContext(@NotNull SEIModel sei, @NotNull List<Class> classesToBind, @NotNull List<TypeReference> typeReferences) throws JAXBException {
                return context;
            }
        };
    }
    
    @ManagedAttribute
    @Nullable
    public JAXBContextFactory getFactory() {
        return this.factory;
    }
    
    @ManagedAttribute
    public String getID() {
        return "http://jax-ws.dev.java.net/features/uses-jaxb-context";
    }
}
